import { createClient, makeTemplateTag } from 'gremlin';

export class MyClass {
    constructor(port, server) {
        let client = createClient(port, server);
        this.gremlin = makeTemplateTag(client);
    }

    clean() {
        return this.gremlin`g.V().drop().iterate()`;
    }

    createVertex(lbl) {
        return this.gremlin`g.addV(label, ${lbl})`;
    }

    readVertexByLabel(lbl) {
        return this.gremlin`g.V().hasLabel(${lbl})`;
    }

    // vertices must exist
    createEdge(fromVertexId, edgelbl, toVertexId) {
        return this.gremlin`g.V(${fromVertexId}).addE(${edgelbl}).to(${toVertexId})`;
    }

    commit() {
        return this.gremlin`g.tx().commit()`
        .catch(e => console.error(e));
    }
}
