import { MyClass } from './GremlinClient';

it('gremlin test', () => {
    let firstVertexLabel = 'myfirstlabel';
    let secondVertexLabel = 'mysecondlabel';
    let edgeLabel = 'myedgelabel';
    let fromId;
    let toId;

    const myInstance = new MyClass(8182, 'localhost');

    return myInstance.clean()
    .then(result => {
        return myInstance.createVertex(firstVertexLabel);
    })
    .then(vertex => {
        console.log('createVertex first vertex: ', vertex);
        expect(vertex.length).toBe(1);
        let v = vertex[0];
        expect(v.label).toEqual(firstVertexLabel);
        return myInstance.createVertex(secondVertexLabel);
    })
    .then(vertex => {
        console.log('createVertex second vertex: ', vertex);
        expect(vertex.length).toBe(1);
        let v = vertex[0];
        expect(v.label).toEqual(secondVertexLabel);
        return myInstance.readVertexByLabel(firstVertexLabel);
    })
    .then(vertex => {
        console.log('readVertexByLabel from: ', vertex);
        fromId = vertex[0].id;
        console.log('fromId: ', fromId);
        return myInstance.readVertexByLabel(secondVertexLabel);
    })
    .then(vertex => {
        console.log('readVertexByLabel to: ', vertex);
        toId = vertex[0].id;
        console.log('toId: ', toId);
        return myInstance.createEdge(fromId, edgeLabel, toId);
    })
    .then(edge => {
        console.log('createEdge "',edgeLabel ,'" value: ', edge);
        return myInstance.commit();
    })
    .catch(e => console.error(e));
});